using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace mbe
{
	/// <summary>
	/// `FNX
	/// </summary>
	class MbeColors
	{
		/// <summary>
		/// lFnCCgColor쐬
		/// </summary>
		/// <param name="colorint"></param>
		/// <returns></returns>
		public static Color HighLighten(uint colorint)
		{
			int a =(int)( (colorint & 0xFF000000) >> 24 );
			int r =(int)( (colorint & 0x00FF0000) >> 16 );
			int g =(int)( (colorint & 0x0000FF00) >> 8  );
			int b = (int)((colorint & 0x000000FF));

			r = r * 2 + 64; if (r > 0xFF) r = 0xFF;
			g = g * 2 + 64; if (g > 0xFF) g = 0xFF;
			b = b * 2 + 64; if (b > 0xFF) b = 0xFF;

			return Color.FromArgb(a, r, g, b);
		}

		/// <summary>
		/// wi
		/// </summary>
		public const uint DEFAULT_COLOR_BACKGROUND = 0xFF000000;

		/// <summary>
		/// 񃏁[NGA(_̍A)̔wiF
		/// </summary>
        public const uint DEFAULT_COLOR_BG_NOT_WORK_AREA = 0xFF303030;

		/// <summary>
		/// O`F
		/// </summary>
		public const uint DEFAULT_COLOR_DIM = 0xFFB8C9C0;

		/// <summary>
		/// h֊s
		/// </summary>
		public const uint DEFAULT_COLOR_DRL = 0xFFC0C0C0;

		///// <summary>
		///// h
		///// </summary>
		//public const uint DEFAULT_COLOR_HOLE = 0xFF202020;

		/// <summary>
		/// Ig
		/// </summary>
		public const uint DEFAULT_COLOR_SELECT_FRAME = 0xFF808080;

		/// <summary>
		/// \J[\
		/// </summary>
		public const uint DEFAULT_COLOR_CROSS_CURSOR = 0xFFC08000;

		/// <summary>
		/// _}[N
		/// </summary>
		public const uint DEFAULT_COLOR_ORIGIN_MARK = 0xFF808080;

		/// <summary>
		/// Obh_}[N
		/// </summary>
		public const uint DEFAULT_COLOR_GRID_ORIGIN_MARK = 0xFF808000;

		/// <summary>
		/// Xibvʒu}[N
		/// </summary>
		public const uint DEFAULT_COLOR_SNAP_POINT = 0xFF808080;

        /// <summary>
        /// ANeBuȃXibvʒu}[N
        /// </summary>
        public const uint DEFAULT_COLOR_ACTIVE_SNAP_POINT = 0xFFFFFFFF;

        
        /// <summary>
		/// sԍ
		/// </summary>
		public const uint DEFAULT_COLOR_PIN_NUM = 0xFF808080;

		/// <summary>
		/// Obh 
		/// </summary>
		public const uint DEFAULT_COLOR_GRID = 0xFFD0D0D0;

		/// <summary>
		/// iʃ\_WXg
		/// </summary>
		public const uint DEFAULT_COLOR_STC = 0xFFAC5959;

		/// <summary>
		/// cʃ\_WXg
		/// </summary>
		public const uint DEFAULT_COLOR_STS = 0xFF4F4F9D;

		/// <summary>
		/// iʃhLg
		/// </summary>
		public const uint DEFAULT_COLOR_DOC = 0xFFDCBCA5;


		/// <summary>
		/// iʃVN
		/// </summary>
		public const uint DEFAULT_COLOR_PLC = 0xFFFCC403;

		/// <summary>
		/// cʃVN
		/// </summary>
		public const uint DEFAULT_COLOR_PLS = 0xFF3588A4;
		
		/// <summary>
		/// iʃp^[
		/// </summary>
		public const uint DEFAULT_COLOR_CMP = 0xFFFF8080;

        /// <summary>
        /// L2p^[
        /// </summary>
        public const uint DEFAULT_COLOR_L2 = 0xFF800000;

        /// <summary>
        /// L3p^[
        /// </summary>
        public const uint DEFAULT_COLOR_L3 = 0xFF403080;

		/// <summary>
		/// cʃp^[
		/// </summary>
		public const uint DEFAULT_COLOR_SOL = 0xFF6060C0;

		/// <summary>
		/// PTH
		/// </summary>
		public const uint DEFAULT_COLOR_PTH = 0xFF00A000;

		/// <summary>
		/// ̓G[ʒmF(Rg[̔wi)
		/// </summary>
		public const uint DEFAULT_COLOR_INPUTERR = 0xFFFF8000;


		private static uint nColorBackground = DEFAULT_COLOR_BACKGROUND;
		private static uint nColorSelectFrame = DEFAULT_COLOR_SELECT_FRAME;
		private static uint nColorBgNotWorkArea = DEFAULT_COLOR_BG_NOT_WORK_AREA;
		private static uint nColorInputErr = DEFAULT_COLOR_INPUTERR;
		private static uint nColorCrossCursor;
		private static uint nColorOriginMark;
		private static uint nColorGridOriginMark;
		private static uint nColorGrid;
		private static uint nColorSnapPoint;
        private static uint nColorActiveSnapPoint;
        private static uint nColorPinNum;
		
		private static uint[] layerColors;

		private static readonly uint[] layerDefaultColors = 
		{
			DEFAULT_COLOR_PTH,
			DEFAULT_COLOR_PLC,
			DEFAULT_COLOR_STC,
			DEFAULT_COLOR_CMP,
			DEFAULT_COLOR_L2,
			DEFAULT_COLOR_L3,
			DEFAULT_COLOR_SOL,
			DEFAULT_COLOR_STS,
			DEFAULT_COLOR_PLS,
			DEFAULT_COLOR_DIM,
			DEFAULT_COLOR_DRL,
			DEFAULT_COLOR_DOC
		};
		
		public static void InitColor()
		{
			System.Diagnostics.Debug.WriteLine("InitColor()");
			int layerColorCount = layerDefaultColors.Length;
			layerColors = new uint[layerColorCount];
			SetDefaultColor();
		}

		public static void SetDefaultColor()
		{
			int layerColorCount = layerDefaultColors.Length;
			for (int i = 0; i < layerColorCount; i++) {
				layerColors[i] = layerDefaultColors[i];
			}
			
			nColorCrossCursor = DEFAULT_COLOR_CROSS_CURSOR;
			nColorOriginMark = DEFAULT_COLOR_ORIGIN_MARK;
			nColorGridOriginMark = DEFAULT_COLOR_GRID_ORIGIN_MARK;
			nColorGrid = DEFAULT_COLOR_GRID;
			nColorSnapPoint = DEFAULT_COLOR_SNAP_POINT;
            nColorActiveSnapPoint = DEFAULT_COLOR_ACTIVE_SNAP_POINT;
            nColorPinNum = DEFAULT_COLOR_PIN_NUM;
            nColorBackground = DEFAULT_COLOR_BACKGROUND;
			nColorBgNotWorkArea = DEFAULT_COLOR_BG_NOT_WORK_AREA;
			nColorInputErr = DEFAULT_COLOR_INPUTERR;
		}

			

		/// <summary>
		/// ݒf[^Fݒǂݍ
		/// </summary>
		/// <remarks>
		/// ݒf[^̃ftHglׂ͂0B
		/// ݒf[^ǂݍ܂ꂽl0ȂlƂȂB
		/// </remarks>
		public static void LoadSettings()
		{
			//uint ncol;

#if !MONO
            //Properties.Settings.Default.Reload();
#endif

            //ncol = Properties.Settings.Default.CustomColorPTH;
            //if(ncol!=0) PTH = ncol;

            //ncol = Properties.Settings.Default.CustomColorPLC;
            //if(ncol!=0) PLC = ncol;

            //ncol = Properties.Settings.Default.CustomColorSTC;
            //if(ncol!=0) STC = ncol;

            //ncol = Properties.Settings.Default.CustomColorCMP;
            //if(ncol!=0) CMP = ncol;

            //ncol = Properties.Settings.Default.CustomColorL2;
            //if (ncol != 0) L2 = ncol;
            
            //ncol = Properties.Settings.Default.CustomColorL3;
            //if (ncol != 0) L3 = ncol;

            //ncol = Properties.Settings.Default.CustomColorSOL;
            //if(ncol!=0) SOL = ncol;

            //ncol = Properties.Settings.Default.CustomColorSTS;
            //if(ncol!=0) STS = ncol;

            //ncol = Properties.Settings.Default.CustomColorPLS;
            //if(ncol!=0) PLS = ncol;

            //ncol = Properties.Settings.Default.CustomColorDIM;
            //if(ncol!=0) DIM = ncol;

            //ncol = Properties.Settings.Default.CustomColorDRL;
            //if (ncol != 0) DRL = ncol;

            //ncol = Properties.Settings.Default.CustomColorDOC;
            //if(ncol!=0) DOC = ncol;

            //ncol = Properties.Settings.Default.CustomColorOriginMark;
            //if (ncol != 0) OriginMark = ncol;

            //ncol = Properties.Settings.Default.CustomColorGridOrigin;
            //if (ncol != 0) GridOriginMark = ncol;

            //ncol = Properties.Settings.Default.CustomColorGrid;
            //if (ncol != 0) Grid = ncol;

            //ncol = Properties.Settings.Default.CustomColorSnapMark;
            //if (ncol != 0) SnapPoint = ncol;

            //ncol = Properties.Settings.Default.CustomColorActiveSnapMark;
            //if (ncol != 0) ActiveSnapPoint = ncol;

            //ncol = Properties.Settings.Default.CustomColorPinNum;
            //if (ncol != 0) PinNum = ncol;

            //ncol = Properties.Settings.Default.CustomColorCursor;
            //if (ncol != 0) CrossCursor = ncol;

            //ncol = Properties.Settings.Default.CustomColorBgOutside;
            //if (ncol != 0) BgNotWorkArea = ncol;

            //ncol = Properties.Settings.Default.CustomColorBg;
            //if (ncol != 0) Background = ncol;

            //ncol = Properties.Settings.Default.CustomColorInputErr;
            //if (ncol != 0) InputErr = ncol;

		}

		/// <summary>
		/// ݒf[^ɐFݒۑ
		/// </summary>
		public static void StoreSettings()
		{
            //Properties.Settings.Default.CustomColorPTH = PTH;
            //Properties.Settings.Default.CustomColorPLC = PLC;
            //Properties.Settings.Default.CustomColorSTC = STC;
            //Properties.Settings.Default.CustomColorCMP = CMP;
            //Properties.Settings.Default.CustomColorL2  = L2;
            //Properties.Settings.Default.CustomColorL3  = L3;
            //Properties.Settings.Default.CustomColorSOL = SOL;
            //Properties.Settings.Default.CustomColorSTS = STS;
            //Properties.Settings.Default.CustomColorPLS = PLS;
            //Properties.Settings.Default.CustomColorDIM = DIM;
            //Properties.Settings.Default.CustomColorDRL = DRL;
            //Properties.Settings.Default.CustomColorDOC = DOC;
            //Properties.Settings.Default.CustomColorOriginMark = OriginMark;
            //Properties.Settings.Default.CustomColorGridOrigin = GridOriginMark;
            //Properties.Settings.Default.CustomColorGrid = Grid;
            //Properties.Settings.Default.CustomColorSnapMark = SnapPoint;
            //Properties.Settings.Default.CustomColorActiveSnapMark = ActiveSnapPoint;
            //Properties.Settings.Default.CustomColorPinNum = PinNum;
            //Properties.Settings.Default.CustomColorCursor = CrossCursor;
            //Properties.Settings.Default.CustomColorBgOutside = BgNotWorkArea;
            //Properties.Settings.Default.CustomColorBg = Background;
            //Properties.Settings.Default.CustomColorInputErr = InputErr;
            //Properties.Settings.Default.Save();

		}



		public static uint GetLayerColor(int index)
		{
			if (index < 0) index = 0;
			else if (index >= layerColors.Length) index = layerColors.Length - 1;
			return layerColors[index];
		}

		public static void SetLayerColor(int index, uint col)
		{
			if (index < 0) index = 0;
			else if (index >= layerColors.Length) index = layerColors.Length - 1;
			layerColors[index] = col;
		}


		/// <summary>
		/// wiF̐l̐ݒƎ擾
		/// </summary>
		public static uint Background
		{
			get { return nColorBackground; }
			set { nColorBackground = value; }
		}


		/// <summary>
		/// wiF̎擾
		/// </summary>
		public static Color ColorBackground
		{
			get { return Color.FromArgb(unchecked((int)nColorBackground)); }
		}

		/// <summary>
		/// ƃGA̔wiF̐l̐ݒƎ擾
		/// </summary>
		public static uint BgNotWorkArea
		{
			get { return nColorBgNotWorkArea; }
			set { nColorBgNotWorkArea = value; }
		}


		/// <summary>
		/// ƃGA̔wiF̎擾
		/// </summary>
		public static Color ColorBgNotWorkArea
		{
			get { return Color.FromArgb(unchecked((int)nColorBgNotWorkArea)); }
		}

		/// <summary>
		/// ̓G[ʒmF(Rg[̔wi)̐l̐ݒƎ擾
		/// </summary>
		public static uint InputErr
		{
			get { return nColorInputErr; }
			set { nColorInputErr = value; }
		}

		/// <summary>
		/// ̓G[ʒmF(Rg[̔wi)̎擾
		/// </summary>
		public static Color ColorInputErr
		{
			get { return Color.FromArgb(unchecked((int)nColorInputErr)); }
		}


		/// <summary>
		/// O`F̐l̐ݒƎ擾
		/// </summary>
		public static uint Outline
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.DIM]; }
			set { layerColors[(int)MbeLayer.LayerIndex.DIM] = value; }
		}

		/// <summary>
		/// O`F̎擾
		/// </summary>
		public static Color ColorOutline
		{
			get { return Color.FromArgb(unchecked((int)Outline)); }
		}

		/// <summary>
		/// h֊s̐F̐l̐ݒƎ擾
		/// </summary>
		public static uint Drl
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.DRL]; }
			set { layerColors[(int)MbeLayer.LayerIndex.DRL] = value; }
		}

		/// <summary>
		/// h֊s̐F̎擾
		/// </summary>
		public static Color ColorDrl
		{
			get { return Color.FromArgb(unchecked((int)Drl)); }
		}


		/// <summary>
		/// IgF̐l̐ݒƎ擾
		/// </summary>
		public static uint SelectFrame
		{
			get { return nColorSelectFrame; }
			set { nColorSelectFrame = value; }
		}

		/// <summary>
		/// IgF̎擾
		/// </summary>
		public static Color ColorSelectFrame
		{
			get { return Color.FromArgb(unchecked((int)nColorSelectFrame)); }
		}

		/// <summary>
		/// \J[\F̐l̐ݒƎ擾
		/// </summary>
		public static uint CrossCursor
		{
			get { return nColorCrossCursor; }
			set { nColorCrossCursor = value; }
		}

		/// <summary>
		/// \J[\F̎擾
		/// </summary>
		public static Color ColorCrossCursor
		{
			get { return Color.FromArgb(unchecked((int)nColorCrossCursor)); }
		}



		/// <summary>
		/// _}[NF̐l̐ݒƎ擾
		/// </summary>
		public static uint OriginMark
		{
			get{ return nColorOriginMark;}
			set{ nColorOriginMark = value;}
		}

		/// <summary>
		/// _}[NF̎擾
		/// </summary>
		public static Color ColorOriginMark
		{
			get { return Color.FromArgb(unchecked((int)nColorOriginMark)); }
		}


		/// <summary>
		/// Obh_}[NF̐l̐ݒƎ擾
		/// </summary>
		public static uint GridOriginMark
		{
			get { return nColorGridOriginMark; }
			set { nColorGridOriginMark = value; }
		}

		/// <summary>
		/// Obh_}[NF̎擾
		/// </summary>
		public static Color ColorGridOriginMark
		{
			get { return Color.FromArgb(unchecked((int)nColorGridOriginMark)); }
		}


		/// <summary>
		/// Xibvʒu}[N̐F̐l̐ݒƎ擾
		/// </summary>
		public static uint SnapPoint
		{
			get { return MbeColors.nColorSnapPoint; }
			set { MbeColors.nColorSnapPoint = value; }
		}

		/// <summary>
		/// Xibvʒu}[NF̎擾
		/// </summary>
		public static Color ColorSnapPoint
		{
			get { return Color.FromArgb(unchecked((int)nColorSnapPoint)); }
		}

        /// <summary>
        /// Xibvʒu}[N̐F̐l̐ݒƎ擾
        /// </summary>
        public static uint ActiveSnapPoint
        {
            get { return MbeColors.nColorActiveSnapPoint; }
            set { MbeColors.nColorActiveSnapPoint = value; }
        }

        /// <summary>
        /// Xibvʒu}[NF̎擾
        /// </summary>
        public static Color ColorActiveSnapPoint
        {
            get { return Color.FromArgb(unchecked((int)nColorActiveSnapPoint)); }
        }

        
        
        /// <summary>
		/// sԍ̐F̐l̐ݒƎ擾
		/// </summary>
		public static uint PinNum
		{
			get { return MbeColors.nColorPinNum; }
			set { MbeColors.nColorPinNum = value; }
		}

		/// <summary>
		/// sԍ̐F̎擾
		/// </summary>
		public static Color ColorPinNum
		{
			get { return Color.FromArgb(unchecked((int)nColorPinNum)); }
		}

		/// <summary>
		/// Obh̐F̐l̐ݒƎ擾 
		/// </summary>
		public static uint Grid
		{
			get{ return nColorGrid;}
			set{ nColorGrid = value;}
		}

		/// <summary>
		/// Obh̐F̎擾
		/// </summary>
		public static Color ColorGrid
		{
			get { return Color.FromArgb(unchecked((int)nColorGrid)); }
		}

		/// <summary>
		/// X[z[pbhF̐l̐ݒƎ擾
		/// </summary>
		public static uint PTH
		{
		    get { return  layerColors[(int)MbeLayer.LayerIndex.PTH]; }
			set { layerColors[(int)MbeLayer.LayerIndex.PTH] = value; }
		}

		/// <summary>
		/// X[z[pbhF̎擾
		/// </summary>
		public static Color ColorPTH
		{
			get { return Color.FromArgb(unchecked((int)PTH)); }
		}

		/// <summary>
		/// cʃp^[F̐l̐ݒƎ擾
		/// </summary>
		public static uint SOL
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.SOL]; }   // MbeColors.nColorSTS; }
			set { layerColors[(int)MbeLayer.LayerIndex.SOL] = value; }
		}

		/// <summary>
		/// cʃp^[F̎擾
		/// </summary>
		public static Color ColorSOL
		{
			get { return Color.FromArgb(unchecked((int)SOL)); }
		}

		/// <summary>
		/// iʃp^[F̐l̐ݒƎ擾
		/// </summary>
		public static uint CMP
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.CMP]; }   // MbeColors.nColorSTS; }
			set { layerColors[(int)MbeLayer.LayerIndex.CMP] = value; }
		}

		/// <summary>
		/// iʃp^[F̎擾
		/// </summary>
		public static Color ColorCMP
		{
			get { return Color.FromArgb(unchecked((int)CMP)); }
		}




        /// <summary>
        /// L2p^[F̐l̐ݒƎ擾
        /// </summary>
        public static uint L2
        {
            get { return layerColors[(int)MbeLayer.LayerIndex.L2]; }   // MbeColors.nColorSTS; }
            set { layerColors[(int)MbeLayer.LayerIndex.L2] = value; }
        }

        /// <summary>
        /// L2p^[F̎擾
        /// </summary>
        public static Color ColorL2
        {
            get { return Color.FromArgb(unchecked((int)L2)); }
        }


        /// <summary>
        /// L3p^[F̐l̐ݒƎ擾
        /// </summary>
        public static uint L3
        {
            get { return layerColors[(int)MbeLayer.LayerIndex.L3]; }   // MbeColors.nColorSTS; }
            set { layerColors[(int)MbeLayer.LayerIndex.L3] = value; }
        }

        /// <summary>
        /// L3p^[F̎擾
        /// </summary>
        public static Color ColorL3
        {
            get { return Color.FromArgb(unchecked((int)L3)); }
        }









		/// <summary>
		/// cʃ\_WXgF̐l̐ݒƎ擾
		/// </summary>
		public static uint STS
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.STS];	}   // MbeColors.nColorSTS; }
			set { layerColors[(int)MbeLayer.LayerIndex.STS] = value; }
		}

		/// <summary>
		/// cʃ\_WXgF̎擾
		/// </summary>
		public static Color ColorSTS
		{
			get { return Color.FromArgb(unchecked((int)STS)); }
		}

		/// <summary>
		/// iʃ\_WXgF̐l̐ݒƎ擾
		/// </summary>
		public static uint STC
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.STC]; }
			set { layerColors[(int)MbeLayer.LayerIndex.STC] = value; }
		}

		/// <summary>
		/// iʃ\_WXgF̎擾
		/// </summary>
		public static Color ColorSTC
		{
			get { return Color.FromArgb(unchecked((int)STC)); }
		}


		/// <summary>
		/// cʃVNF̐l̐ݒƎ擾
		/// </summary>
		public static uint PLS
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.PLS]; }   // MbeColors.nColorSTS; }
			set { layerColors[(int)MbeLayer.LayerIndex.PLS] = value; }
		}

		/// <summary>
		/// cʃVNF̎擾
		/// </summary>
		public static Color ColorPLS
		{
			get { return Color.FromArgb(unchecked((int)PLS)); }
		}

		/// <summary>
		/// iʃVNF̐l̐ݒƎ擾
		/// </summary>
		public static uint PLC
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.PLC]; }
			set { layerColors[(int)MbeLayer.LayerIndex.PLC] = value; }
		}

		/// <summary>
		/// iʃVNF̎擾
		/// </summary>
		public static Color ColorPLC
		{
			get { return Color.FromArgb(unchecked((int)PLC)); }
		}

		/// <summary>
		/// fBW̐l̐ݒƎ擾
		/// </summary>
		public static uint DIM
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.DIM]; }
			set { layerColors[(int)MbeLayer.LayerIndex.DIM] = value; }
		}

		/// <summary>
		/// fBW̐F̎擾
		/// </summary>
		public static Color ColorDIM
		{
			get { return Color.FromArgb(unchecked((int)DIM)); }
		}


		/// <summary>
		/// h̐l̐ݒƎ擾
		/// </summary>
		public static uint DRL
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.DRL]; }
			set { layerColors[(int)MbeLayer.LayerIndex.DRL] = value; }
		}

		/// <summary>
		/// fBW̐F̎擾
		/// </summary>
		public static Color ColorDRL
		{
			get { return Color.FromArgb(unchecked((int)DRL)); }
		}



		/// <summary>
		/// hLgF̐l̐ݒƎ擾
		/// </summary>
		public static uint DOC
		{
			get { return layerColors[(int)MbeLayer.LayerIndex.DOC]; }
			set { layerColors[(int)MbeLayer.LayerIndex.DOC] = value; }
		}

		/// <summary>
		/// hLg̐F̎擾
		/// </summary>
		public static Color ColorDOC
		{
			get { return Color.FromArgb(unchecked((int)DOC)); }
		}



	}
}
